var newsMessageModalOpen = false;

$(document).ready(function() {
	/* GA call triggers */
	$('body').on('click', '[data-gaeventparams]', function(e) {
		var gaEventParams = $(this).data('gaeventparams');
		
		if(gaEventParams != '') {
			TriggerGAEventTrackerCall(gaEventParams);
		}
	});
	
	$('body').on('click', '[data-elem-gaparams]', function(e) {
		var gaEventParams = $(this).data('elem-gaparams');
		
		if(gaEventParams != '') {
			TriggerGAEventTrackerCall(gaEventParams);
		}
	});
	
	$('body').on('click', '.call-to-action-standalone a', function(e) {
		var gaEventParams = $('body').data('calltoaction-gaparams');
		console.log("CTA click");
		if(gaEventParams != '') {
			TriggerGAEventTrackerCall(gaEventParams);
		}
	});
	
	$('body').on('click', 'iframe', function(e) {
		console.log("iframe click");
		if($(this).attr('src').indexOf('youtube') >= 0) {
			var gaEventParams = $('body').data('data-emvid-gaparams');
			
			if(gaEventParams != '') {
				TriggerGAEventTrackerCall(gaEventParams);
			}
		}
	});
	
	/* End of GA call triggers */
	
	var isMobile = false;
	var detectClientBrowser = helperUtilities.tryDetectBrowser();
	if(detectClientBrowser != "") {
		isMobile = true;
		
		if(detectClientBrowser.indexOf("ios") >= 0) {
			$("body").addClass("rf-ios-specific-styles");
		}
	}
	else {
		var isSafari = /constructor/i.test(window.HTMLElement);
		
		if(isSafari) {
			$("body").addClass("rf-safari-specific-styles");
		}
	}
	
	AdjustLanguageSwitcher();
	
	$('[data-main-content-intro-target]').on("click", function(e) {
		var targetProduct = $(this).data("main-content-intro-target");
		
		//var targetProductUrlAnchor = $('.product-list-item.product-item-' + targetProduct + ' a');
		// if(targetProductUrlAnchor.data('gaeventparams') != '') {
			// TriggerGAEventTrackerCall(targetProductUrlAnchor.data('gaeventparams'));
		// }
		
		var gaEventParams = $(this).data('gaeventparams');
		if(gaEventParams != '') {
			TriggerGAEventTrackerCall(gaEventParams);
		}
		
		var targetProductUrl = $('.product-item.product-item-' + targetProduct + ' a').attr('href');
		
		//var targetProductUrl = $(".main-" + targetProduct + "-button a").attr("href");
			
		if(typeof targetProductUrl !== 'undefined') {
			if(targetProductUrl.substr(0,1) == "/") {
				if(window.location.href.indexOf("/home/") >= 0) {
					window.location.href = window.location.href.replace("/home/", targetProductUrl);
				}
				else {
					if(window.location.href.slice(-1) == '/') {
						targetProductUrl = targetProductUrl.substring(1);
					}
					
					window.location.href = window.location.href + targetProductUrl;
				}
			}
			else {
				window.location.href = targetProductUrl;
			}
		}
	});
	
	$('.home-product-trigger').on('click', function(e) {
		var gaEventParams = $(this).parents('.home-product').first().data('productgaeventparams');
		if(gaEventParams != '') {
			TriggerGAEventTrackerCall(gaEventParams);
		}
		
		var _isProductLink = false;
		if(typeof $(this).data('isproductlink') === 'boolean') {
			_isProductLink = $(this).data('isproductlink');
		}
		else if(typeof $(this).data('isproductlink') === 'string') {
			_isProductLink = $(this).data('isproductlink') == 'true';
		}
		
		if(!_isProductLink) {
			var _productLink = $(this).parents('.home-product').first().find('a.home-product-trigger').first().attr('href');
			
			if(_productLink != '') {
				if(_productLink.substring(0, 1) != '/') {
					_productLink = '/' + _productLink;
				}
				
				window.location.href = _productLink;
			}
		}
	});
	
	$('.nav.navbar-nav a[data-toggle="dropdown"]').on('click', function(e) {
		try {
			if(typeof hideMainMenu !== 'undefined') {
				hideMainMenu();
			}
			else {
			}
		}
		catch(ex) {
		}
	});
	
	$('[data-target="#TopSubmenuNavbarCollapse"]').on('click', function(e) {
		try {
			if(typeof hideMainMenu !== 'undefined') {
				hideMainMenu();
			}
			else {
			}
		}
		catch(ex) {
		}
	});
	
	$(".mainmenu-top .navbar-toggle").on("click", function (e) {
		$(".product-menu-top").hasClass("product-menu-top-hidden") ? $(".product-menu-top").removeClass("product-menu-top-hidden") : $(".product-menu-top").addClass("product-menu-top-hidden");
	});
	
	$(".product-menu-top .navbar-toggle").on("click", function(e) {
		$(".mainmenu-top .navbar-toggle").hasClass("mainmenu-top-navbar-toggle-hidden") ? $(".mainmenu-top .navbar-toggle").removeClass("mainmenu-top-navbar-toggle-hidden") : $(".mainmenu-top .navbar-toggle").addClass("mainmenu-top-navbar-toggle-hidden");
	});
	
	$(".sub-menu-pulldown.dropdown-menu li").on("click", function(e) {
		//$(this).parents(".navbar-collapse.collapse").first().removeClass("in");
		//$(this).parents(".navbar-collapse.collapse").attr("aria-expanded", "false");
		$(this).parents(".product-menu-top").find('[data-target="#TopSubmenuNavbarCollapse"]').click();
	});
	
	$("[data-target-page]").on("click", function(e) {
		var currentUrl = window.location.href;
		
		var newUrl = currentUrl.replace("index.html", "product.html");
		window.location.href = newUrl;
		//var newUrl = currentUrl.replace("index.html", $(this).data("target-page"));
		
		//window.location.href = newUrl;
	});
	
	$(".single-product-reference .readmore-link.readmore-internal-link").on("click", function(e) {
		e.preventDefault();
		
		var referenceText = $("#reference-" + $(this).data("reference-id")).html();
		
		$("#ReferenceModal .modal-body").html(referenceText);
		$("#ReferenceModal").modal('show');
	});
	
	$(".single-news-message .readmore-link").on("click", function(e) {
		/*
		e.preventDefault();
		
		var messageText = $("#news-message-" + $(this).data("newsmessage-id")).html();
		$("#NewsMessageModal .modal-body").html(messageText);
		$("#NewsMessageModal").modal('show');
		*/
	});
	
	$(".footer-block.references-block .references-product").on("click", function(e) {
		window.location.href = $(this).children(".footer-reference-link").attr("href");
	});
	
	if($('[data-target-external-page]').length) {
		externalPage.init();
	}
	
	if($(".features").length) {
		if($(".features h2").length) {
			$(".features h2").each(function() {
				if($(this).find("a").first().attr("id") != "") {
					$(this).on("click", function(e) {
						var anchorId = $(this).find("a").first().attr("id");
						
						collapse(anchorId, "h2");
					});
				}
			});
		}
		if($(".features h4").length) {
			$(".features h4").each(function() {
				if($(this).find("a").first().attr("id") != "") {
					$(this).on("click", function(e) {
						var anchorId = $(this).find("a").first().attr("id");
						
						collapse(anchorId, "h4");
					});
				}
			});
		}
	}
	
	if($("[data-carousel-images]").length) {
		if(!isMobile) {
			imageCarouselZoom.init();
			
			if($(".carousel-trigger-image").hasClass("carousel-trigger-image-hidden")) {
				$(".carousel-trigger-image").removeClass("carousel-trigger-image-hidden");
			}
			if(!$(".mobile-carousel").hasClass("mobile-carousel-hidden")) {
				$(".mobile-carousel").addClass("mobile-carousel-hidden");
			}
		}
		else {
			if(!$(".carousel-trigger-image").hasClass("carousel-trigger-image-hidden")) {
				$(".carousel-trigger-image").addClass("carousel-trigger-image-hidden");
			}
			if($(".mobile-carousel").hasClass("mobile-carousel-hidden")) {
				$(".mobile-carousel").removeClass("mobile-carousel-hidden");
			}
		}
	}
	
	if($('[data-image-zoom="enabled"]').length && !isMobile) {
		imageZoom.init();
	}
	
	$("#NewsMessageModal").on('shown.bs.modal', function(e) {
		newsMessageModalOpen = true;
	});
	
	$("#NewsMessageModal").on('hidden.bs.modal', function(e) {
		newsMessageModalOpen = false;
	});
	
	$("#imageCarouselModal").on('hidden.bs.modal', function(e) {
		if(newsMessageModalOpen) {
			if(!$("body").hasClass('modal-open')) {
				$("body").addClass('modal-open');
			}
		}
	});
	
	if($(".roomsignage-customlooks-container").length) {
		$(".roomsignage-customlooks-container .roomsignage-customlooks-example").on("click", function(e) {
			var imageSource = $(this).children("img").first().attr("src");
			var isActive = $(this).hasClass("roomsignage-customlooks-example-shown");
			
			if(isActive) {
				$(this).removeClass("roomsignage-customlooks-example-shown");
				$(".roomsignage-customlooks-example").removeClass("roomsignage-customlooks-example-inactive");
				$(".roomsignage-customlooks-zoomexample").addClass("roomsignage-customlooks-zoomexample-hidden");
			}
			else {
				$(".roomsignage-customlooks-example").removeClass("roomsignage-customlooks-example-shown");
				$(".roomsignage-customlooks-example").addClass("roomsignage-customlooks-example-inactive");
				$(this).addClass("roomsignage-customlooks-example-shown");
				$(this).removeClass("roomsignage-customlooks-example-inactive");
				$(".roomsignage-customlooks-zoomexample").removeClass("roomsignage-customlooks-zoomexample-hidden");
				$(".roomsignage-customlooks-zoomexample").empty();
				$(".roomsignage-customlooks-zoomexample").append('<img src="' + imageSource + '" border="0" />');
			}
		});
	}
	
	/* added on and disabled on 2019-03-20, Frans decided he didn't want a row of clickable thumbnails after all
	if($('.hardware-example-container').length) {
		$('.hardware-example-container .hardware-example').on('click', function(e) {
			var imageSource = $(this).children('img').first().attr('src');
			var factsheetSource = $(this).children('a').length ? $(this).children('a').first().attr('src') : '';
			var isActive = $(this).hasClass('hardware-example-shown');
			
			var parentId = $(this).parents('.hardware-example-container').first().attr('id');
			var zoomExampleId = $(this).parents('.hardware-example-container').first().find('.hardware-zoomexample').first().attr('id');
			
			if(isActive) {
				$(this).removeClass('hardware-example-shown');
				$('#' + parentId).find('.hardware-example').removeClass('hardware-example-inactive');
				$('#' + zoomExampleId).addClass('hardware-zoomexample-hidden');
				$('#' + zoomExampleId).empty();
			}
			else {
				$('#' + parentId).find('.hardware-example').removeClass('hardware-example-shown');
				$('#' + parentId).find('.hardware-example').addClass('hardware-example-inactive');
				$(this).addClass('hardware-example-shown');
				$(this).removeClass('hardware-example-inactive');
				$('#' + zoomExampleId).empty();
				$('#' + zoomExampleId).append('<img src="' + imageSource + '" border="0" />');
				if(factsheetSource != '') {
					$('#' + zoomExampleId).append('<a href="' + factsheetSource + '" target="_blank">Factsheet</a>');
				}
				$('#' + zoomExampleId).removeClass('hardware-zoomexample-hidden');
			}
		});
	}
	*/
});

var externalPage = {
	init: function() {
		$("#externalPageModal").on("hide.bs.modal", function(e) {
			$("#externalPageFrame").attr("src", "");
		});
		
		$("#externalPageModal").on('shown.bs.modal', function(e) {
			var modalBodyHeight = $("#externalPageModal .modal-body").height();
			
			if($("#externalPageFrame").hasClass("dynamic-frame-class")) {
				$("#externalPageFrame").removeClass("dynamic-frame-class");
			}
			
			$("<style type='text/css' id='dynamicFrameClass'> .dynamic-frame-class { height: " + (modalBodyHeight - 20) + "px!important; }</style>").appendTo("head");
			$("#externalPageFrame").addClass("dynamic-frame-class");
			
			//$("#externalPageFrame").height((modalBodyHeight - 30) + "px");
		});
	
		$("[data-target-external-page]").on("click", function(e) {
			var externalPageUrl = $(this).data("target-external-page");
			
			$("#externalPageFrame").attr("src", externalPageUrl);
			
			$("#externalPageModal").modal({
				show: true
			});
		});
	}
};

var imageCarouselZoom = {
	maxWidth: 900,
	maxHeight: 600,
	init: function() {
		$("#imageCarouselModal").modal({
			backdrop: true,
			keyboard: false,
			show: false
		});
		
		//$("[data-carousel-images]").on("click", function(e) {
		$(document).on("click", "[data-carousel-images]", function(e) {
			$("#image-modal-carousel .carousel-inner").html("");
			var thisCarouselImages = $(this).data("carousel-images").split("||");
			
			var carouselImageCounter = 0;
			$.each(thisCarouselImages, function(index, entry) {
				var extraClass = "";
				if(carouselImageCounter == 0) {
					extraClass = " active";
				}
				
				$('<div class="item' + extraClass + '"><img src="' + entry + '" alt="" /></div>').appendTo("#image-modal-carousel .carousel-inner");
				
				carouselImageCounter++;
			});
			
			$("#imageCarouselModal").modal({
				show: true
			});
		});
			
	}
};

var imageZoom = {
	maxWidth: 900,
	maxHeight: 600,
	init: function() {
		$("#imageModal").modal({
			backdrop: true,
			keyboard: false,
			show: false
		});
		
		$("#imageModal").on('hide.bs.modal', function(e) {
			$("#imageModal .modal-body img").attr("src", "");
			
			if($("#dynamicImageZoomClass").length) {
				$("#dynamicImageZoomClass").remove();
			}
			if($("#imageModal .modal-dialog").hasClass("dynamic-image-zoom-class")) {
				$("#imageModal .modal-dialog").removeClass("dynamic-image-zoom-class");
			}
		});
		
		$("#imageModal").on('shown.bs.modal', function(e) {
			var imageWidth = $("#imageModal .modal-body img").width();
			var imageHeight = $("#imageModal .modal-body img").height();
			
			var modalWidth = 0;
			var modalHeight = 0;
			if(imageWidth > imageZoom.maxWidth) {
				modalWidth = imageZoom.maxWidth + 30;
			}
			else {
				modalWidth = imageWidth + 30;
			}
			
			if($("#imageModal .modal-dialog").width() < modalWidth) {
				$("<style type='text/css' id='dynamicImageZoomClass'> .dynamic-image-zoom-class { width: " + modalWidth + "px; max-width: " + modalWidth + "px; }</style>").appendTo("head");
				$("#imageModal .modal-dialog").addClass("dynamic-image-zoom-class");
			}
			
			$("#imageModal img").on("click", function(e) {
				$("#imageModal").modal('hide');
			});
		});
		
		$('[data-image-zoom="enabled"]').each(function() {
			$(this).css("cursor", "pointer");
		
			$(this).on("click", function(e) {
				var imageSource = $(this).attr("src");
				
				if(imageSource.indexOf("?") >= 0) {
					imageSource = imageSource.substr(0, imageSource.indexOf("?"));
				}
				
				$("#imageModal .modal-body img").attr("src", imageSource);
				
				$("#imageModal").modal({
					show: true
				});
			});
		});
	}
};

var helperUtilities = {
	tryDetectBrowser: function () {
        var uaString = window.navigator.userAgent;
        var uaDetected = "";

        if (uaString.indexOf('Android') > -1 && (/Chrome\/[.0-9]*/).test(uaString)) {
            uaDetected = "android";
        }
        else if (uaString.indexOf('Mozilla') > -1 && uaString.indexOf('Mobile Safari') > -1 && uaString.indexOf('Android') > -1 && uaString.indexOf('Chrome') == -1) {
            uaDetected = "androidStock";
        }
        else if (uaString.indexOf('Firefox') > -1 && (uaString.indexOf('Mobile') > -1 || uaString.indexOf('Tablet') > -1)) {
            uaDetected = "firefoxMobile";
        }
        else if ((/iphone|ipad|ipod/i).test(uaString)) {
            var uaOS = "ios";
            var uaOSVersion = uaString.match(/(OS) (\d+[_\.]\d+)/);
            uaOSVersion = uaOSVersion && uaOSVersion[2] ? +uaOSVersion[2].replace('_', '.') : 0;

            uaDetected = uaOS + (uaOSVersion + '').substr(0, 1);
        }

        return uaDetected;
    }
};

function collapse(source, parentElementType) {
	var anchor = $("#" + source);
	
	if(anchor.find(".icon").length) {
		var icon = anchor.find(".icon");
	}
	else if(anchor.siblings(".icon").length) {
		var icon = anchor.siblings(".icon");
	}
	
	var list = anchor.parent(parentElementType).next("ul");
	if (list.is(".collapsed")) {
		list.removeClass("collapsed")
		icon.text("▼");
	}
	else {
		list.addClass("collapsed");
		icon.text("►");
	}
}

function AdjustLanguageSwitcher() {
	if($(".languageswitcher-container").length) {
		$(".languageswitcher-container").appendTo(".language-switcher-item");
	}
	
	$(".language-switcher-item li").each(function() {
		var linkText = "";
		var isCurrent = false;
		
		if($(this).find("a").length) {
			linkText = $(this).find("a").html();
			
			linkText = AbbreviateLanguageSwitcherText(linkText);
			
			$(this).find("a").html(linkText);
		}
		else if($(this).find("strong").length) {
			linkText = $(this).find("strong").html();
			
			linkText = AbbreviateLanguageSwitcherText(linkText);
			
			$(this).find("strong").html(linkText);
			
			isCurrent = true;
		}
		
		if(isCurrent) {
			$(this).addClass("language-active");
			$(this).removeClass("language-inactive");
		}
		else {
			$(this).removeClass("language-active");
			$(this).addClass("language-inactive");
		}
	});
	
	if(!$(".language-switcher-item .language-item-separator").length) {
		$('<li class="language-item-separator">&nbsp;</li>').insertAfter(".language-switcher-item li:first");
	}
}

function AbbreviateLanguageSwitcherText(languageText) {
	switch(languageText.toLowerCase()) {
		case "nederlands":
			languageText = "NL";
			break;
		case "english":
			languageText = "ENG";
			break;
	}
	
	return languageText;
}

function TriggerGAEventTrackerCall(gaParams) {
	try {
		console.log("params? ", gaParams);
		
		var _gaParams = gaParams.split(',');
		var _gaParamsTemp = [];
		
		$.each(_gaParams, function(index, entry) {
			_gaParamsTemp.push(entry.trim());
		});
		console.log("_gaparams: ", _gaParamsTemp);
		//ga(gaParams);
		ga(_gaParams[0].trim(),_gaParams[1].trim(),_gaParams[2].trim(),_gaParams[3].trim(),_gaParams[4].trim());
	}
	catch(ex) {
		console.log("ga-error: ", ex);
	}
}


